function createEmotionGISC(y1, y2, y3)
%CREATEFIGURE(Y1,Y2,Y3)
%  Y1:  matrix of y data
%  Y2:  vector of y data
%  Y3:  matrix of y data
 
%  Auto-generated by MATLAB on 16-Oct-2009 14:42:03
 
%% Create figure
figure1 = figure(...
  'FileName','C:\Users\Jukkis\Desktop\frontiers\uudet kuvat\EMOTION_GISC.fig',...
  'PaperPosition',[0.6345 6.345 20.3 15.23],...
  'PaperSize',[20.98 29.68]);
 
%% Create axes
axes1 = axes(...
  'Position',[0.03568 0.1794 0.3932 0.7559],...
  'YTick',[1 2 3 4 5],...
  'Parent',figure1);
axis(axes1,[1 24 1 5]);
xlabel(axes1,'Time interval index');
ylabel(axes1,'Frontal polar GISC (%)');
grid(axes1,'on');
hold(axes1,'all');
 
%% Create mutliple lines using matrix input to plot
plot1 = plot(y1);
set(plot1(1),...
  'Color',[1 0 0],...
  'LineStyle','--',...
  'LineWidth',1.5,...
  'Marker','o');
set(plot1(2),...
  'Color',[0 1 0],...
  'LineStyle',':',...
  'LineWidth',1.5,...
  'Marker','.',...
  'MarkerSize',15);
set(plot1(3),...
  'Color',[0 0 1],...
  'LineWidth',1.5,...
  'Marker','diamond');
 
%% Create legend
legend1 = legend(axes1,{'Valence','Arousal','GISC'},'Position',[0.1307 0.6998 0.1123 0.1784]);
 
%% Create axes
axes2 = axes(...
  'Position',[0.5497 0.1797 0.3893 0.7615],...
  'YTick',[1 2 3 4 5],...
  'Parent',figure1);
axis(axes2,[1 39 1 5]);
xlabel(axes2,'Time interval index');
ylabel(axes2,'Valence / Arousal rate');
grid(axes2,'on');
hold(axes2,'all');
 
%% Create plot
plot2 = plot(y2,...
  'Color',[0 1 0],...
  'LineStyle',':',...
  'LineWidth',1.5,...
  'Marker','.',...
  'MarkerSize',15,...
  'Parent',axes2);
 
%% Create mutliple lines using matrix input to plot
plot3 = plot(y3);
set(plot3(1),...
  'Color',[1 0 0],...
  'LineStyle','--',...
  'LineWidth',1.5,...
  'Marker','o');
set(plot3(2),...
  'Color',[0 0 1],...
  'LineWidth',1.5,...
  'Marker','diamond');
 
%% Create legend
legend2 = legend(axes2,{'Valence','Arousal','GISC'},'Position',[0.6573 0.707 0.1135 0.2078]);
 
%% Create textbox
annotation1 = annotation(...
  figure1,'textbox',...
  'Position',[0.4261 0.09562 0.04324 0.9132],...
  'LineStyle','none',...
  'FitHeightToText','off',...
  'String',{'','4.94','','','','3.84','','','','2.75','','','','1.65','','','','0.55'});
 
%% Create textbox
annotation2 = annotation(...
  figure1,'textbox',...
  'Position',[0.937 0.1021 0.04324 0.9132],...
  'LineStyle','none',...
  'FitHeightToText','off',...
  'String',{'','4.94','','','','3.84','','','','2.75','','','','1.65','','','','0.55'});
 
%% Create textbox
annotation3 = annotation(...
  figure1,'textbox',...
  'Position',[-0.004278 0.9098 0.03743 0.101],...
  'LineStyle','none',...
  'FontSize',12,...
  'FontWeight','bold',...
  'String',{'A'},...
  'FitHeightToText','on');
 
%% Create textbox
annotation4 = annotation(...
  figure1,'textbox',...
  'Position',[0.5109 0.9075 0.03743 0.101],...
  'LineStyle','none',...
  'FontSize',12,...
  'FontWeight','bold',...
  'String',{'B'},...
  'FitHeightToText','on');
 
